local ANFrame = CreateFrame("Frame")
local ANEvents = {}
local defaultAutoNomiOptions = {}
defaultAutoNomiOptions['AutoNomiEnabled'] = true
defaultAutoNomiOptions['AutoNomiUsedMats'] = {}

function ANMessage(message)
    DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ff[AutoNomi]|r: " .. message)
end

function ANEvents:GOSSIP_SHOW(arg1)
    if (GossipFrameNpcNameText:GetText() ~= "Nomi") then
        return
    end
    if (AutoNomiOptions['AutoNomiEnabled'] == false) then
        --ANMessage(' - Disabled')
        return
    end

    local _, _, shipmentCapacity, shipmentsReady, shipmentsTotal, _, _, timeleftString = C_Garrison.GetLandingPageShipmentInfoByContainerID(122);
    if (shipmentsTotal == shipmentCapacity) then
        ANMessage(' The queue is full come back in ' .. timeleftString)
        if (shipmentsReady > 0) then
            ANMessage(' You may need to open the Class Hall Report window to refresh the counter')
        end
        return
    end

    local title, gtype = {}, {}
    local mat = ''
    local numOptions = GetNumGossipOptions()

    title[1], gtype[1],
    title[2], gtype[2],
    title[3], gtype[3],
    title[4], gtype[4],
    title[5], gtype[5],
    title[6], gtype[6],
    title[7], gtype[7],
    title[8], gtype[8],
    title[9], gtype[9],
    title[10], gtype[10],
    title[11], gtype[11],
    title[12], gtype[12],
    title[13], gtype[13],
    title[14], gtype[14],
    title[15], gtype[15],
    title[16], gtype[16],
    title[17], gtype[17],
    title[18], gtype[18],
    title[19], gtype[19],
    title[20], gtype[20]
    = GetGossipOptions()

    for k, v in pairs(title) do
        if ((gtype[k] == 'workorder') and (v:gmatch("Research recipes using "))) then
            mat = v:sub(24)

            if (AutoNomiOptions['AutoNomiUsedMats'][mat]) then
                numOptions = numOptions - 1
            else
                ANMessage("Selected research for " .. mat)
                AutoNomiOptions['AutoNomiUsedMats'][mat] = true
                SelectGossipOption(k)
                break
            end
        else
            numOptions = numOptions - 1
        end
    end

    if (numOptions == 0) then
        ANMessage("Resetting used recipes")
        AutoNomiOptions['AutoNomiUsedMats'] = {}
    end
end

function ANEvents:ADDON_LOADED(arg1)
    if (arg1 == "AutoNomi") then
        ANFrame:UnregisterEvent('ADDON_LOADED')
        ANMessage("v 1.0 Loaded")

        SlashCmdList["ANOMICMD"] = ANParseCommand
        SLASH_ANOMICMD1 = "/autonomi"
        SLASH_ANOMICMD2 = "/anomi"
    end
end

function ANEvents:SHIPMENT_CRAFTER_OPENED(arg1)
    if (arg1 == 122) then
        --GarrisonCapacitiveDisplayFrame
        --StartWorkOrderButton
        GarrisonCapacitiveStartWorkOrder_OnClick()
        HideUIPanel(GarrisonCapacitiveDisplayFrame)
        C_Garrison.CloseTradeskillCrafter()
    end
end

function ANEvents:VARIABLES_LOADED(arg1)
    ANFrame:UnregisterEvent('VARIABLES_LOADED')

    if (AutoNomiOptions == nil) then
        AutoNomiOptions = defaultAutoNomiOptions
    end

    if (AutoNomiOptions['AutoNomiEnabled']) then
        ANMessage(' - Enabled')
    else
        ANMessage(' - Disabled')
    end
end

ANFrame:SetScript("OnEvent", function(self, event, ...)
    ANEvents[event](self, ...)
end)

for k, v in pairs(ANEvents) do
    ANFrame:RegisterEvent(k)
end

function ANParseCommand(cmd)
    local goodcmd = false;
    if (cmd:upper() == "OFF") then
        goodcmd = true
        AutoNomiOptions['AutoNomiEnabled'] = false
        ANMessage(' - Disabled')
    end
    if (cmd:upper() == "ON") then
        goodcmd = true
        AutoNomiOptions['AutoNomiEnabled'] = true
        ANMessage(' - Enabled')
    end
    if (goodcmd == false) then
        ANMessage("CLI commands:")
        ANMessage("/anomi or /autonomi")
        ANMessage("/autonomi off => disable AutoNomi")
        ANMessage("/autonomi on => enable AutoNomi")
    end
end
